#ifndef PMIROIR_H
#define PMIROIR_H

#include <qmainwindow.h>
#include <qtimer.h>
#include <qstring.h>
#include <qrect.h>
#include <qpen.h>

#include "memory_cs.h"
#include "constants.h"

#define CFXGADev "/dev/cfxga0a"

class PMImage;
class QKeyEvent;
class SketchPainter;

class PMiroir : public QMainWindow {
  Q_OBJECT

public:
  PMiroir(QWidget *parent = 0);
  ~PMiroir(void);

  void keyPressEvent(QKeyEvent *);
  void mousePressEvent(QMouseEvent *);
  void mouseMoveEvent(QMouseEvent *);
  void mouseReleaseEvent(QMouseEvent *);
  void paintEvent(QPaintEvent *);

  void resizeEvent(QResizeEvent *);

  void setFullScreen(void);
  void updateRect(QRect);
  QString imageDir(void) {return _imagedir;};

  enum {MirrorMode = 0, ImageMode, NumOfModes};

 private:
  PMImage *_image;
  SketchPainter *_painter;
  QPen *_pen;
  QPen _pen1, _pen2, _pen3;
  QRect _fullrect;
  QString _imagedir;

  unsigned short int *_buf, *_bbuf, *_buffer0, *_buffer1;
  unsigned long int *_chk, *_check0, *_check1;
  int _vgafp;
  QTimer *_timer;
  int _mode;
  int _x0, _x1, _y0, _y1;

  void convert_geometry(int *, int *);

  void read_buf(void);
  void write_buf(void);
  void write_buf(QRect&);
  void write_buf(unsigned short int*, QRect);
  void write_buf_dp(unsigned short int*, QRect);
  void exchange_buf(void);
  void update_buf(void);
  bool update_xpos(int, int*, int*);

  void setup_menu(void);

 public slots:
  void reload_buf(void);
  void quit_application(void);
  void change_pen(void);
  void setImagedir(void);
};

#endif // PMIROIR_H
